"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayCompact = void 0;
/**
 * @public
 * Strips null and undefined items from arrays (non mutative).
 *
 * @remarks
 * See {@link arrayCompact}.
 */
function arrayCompact(items) {
    const result = [];
    for (let i = 0, iEnd = items.length; i < iEnd; ++i) {
        const item = items[i];
        if (item != null) {
            result.push(item);
        }
    }
    return result;
}
exports.arrayCompact = arrayCompact;
//# sourceMappingURL=array-compact.js.map