/**
 * @public
 * Like `Array.forEach`.
 * @remarks
 * Has more consistent performance characteristics cross platform than the built in `Array.forEach`.
 *
 * See {@link arrayForEach}.
 */
export declare function arrayForEach<TItem>(items: ArrayLike<TItem>, callback: (item: TItem, index: number) => void): void;
