"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayForEach = void 0;
/**
 * @public
 * Like `Array.forEach`.
 * @remarks
 * Has more consistent performance characteristics cross platform than the built in `Array.forEach`.
 *
 * See {@link arrayForEach}.
 */
function arrayForEach(items, callback) {
    for (let i = 0, iEnd = items.length; i < iEnd; ++i) {
        callback(items[i], i);
    }
}
exports.arrayForEach = arrayForEach;
//# sourceMappingURL=array-for-each.js.map