"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayLast = void 0;
/**
 * @public
 * Gets the last value in `ArrayLike`.
 *
 * @returns The first value in `map`, otherwise `undefined` where size 0.
 *
 * @remarks
 * See {@link mapFirstValue}.
 */
function arrayLast(items) {
    if (items.length === 0) {
        return undefined;
    }
    return items[items.length - 1];
}
exports.arrayLast = arrayLast;
//# sourceMappingURL=array-last.js.map