/**
 * @public
 * Like `Array.map`.
 * @remarks
 * Has more consistent performance characteristics cross platform than the built in `Array.map`
 *
 * See {@link arrayMap}.
 */
export declare function arrayMap<TItem, TMapped>(items: ArrayLike<TItem>, callback: (item: TItem, index: number) => TMapped): TMapped[];
