"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayNormalizeEmptyToUndefined = void 0;
/**
 * @public
 * Replaces length 0 `ArrayLike` with `undefined`.
 * @returns `array` if it's an `ArrayLike` of length greater than 0, otherwise `undefined`.
 *
 * @remarks
 * See {@link arrayNormalizeEmptyToUndefined}.
 */
function arrayNormalizeEmptyToUndefined(array) {
    if (array == null || array.length === 0) {
        return undefined;
    }
    return array;
}
exports.arrayNormalizeEmptyToUndefined = arrayNormalizeEmptyToUndefined;
//# sourceMappingURL=array-normalize-empty-to-undefined.js.map