"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayUnique = void 0;
/**
 * @public
 * Creates a new array with no duplicates, using standard object equality.
 *
 * @remarks
 * See {@link arrayUnique}.
 */
function arrayUnique(items) {
    const collected = new Set();
    for (let i = 0, iEnd = items.length; i < iEnd; ++i) {
        collected.add(items[i]);
    }
    return Array.from(collected);
}
exports.arrayUnique = arrayUnique;
//# sourceMappingURL=array-unique.js.map