"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMargin2dCtor = void 0;
const mat2_factory_js_1 = require("../../mat2/mat2-factory.js");
const range2d_js_1 = require("../range2d/range2d.js");
const normalized_data_view_provider_js_1 = require("../../normalized-data-view/normalized-data-view-provider.js");
const get_mat2_ctor_js_1 = require("../../mat2/get-mat2-ctor.js");
/**
 * @internal
 */
function getMargin2dCtor(ctor) {
    var _a;
    return _a = class Margin2dImpl extends (0, get_mat2_ctor_js_1.getMat2Ctor)(ctor) {
            getLeft() {
                return this[0];
            }
            getRight() {
                return this[1];
            }
            getTop() {
                return this[2];
            }
            getBottom() {
                return this[3];
            }
            setLeft(value) {
                this[0] = value;
            }
            setRight(value) {
                this[1] = value;
            }
            setTop(value) {
                this[2] = value;
            }
            setBottom(value) {
                this[3] = value;
            }
            sumX() {
                return this[0] + this[1];
            }
            sumY() {
                return this[2] + this[3];
            }
            getInnerRange(range, result = this.constructor.rangeCtor.factory.createOneEmpty()) {
                result[0] = range[0] + this[0]; // xMin
                result[1] = range[1] - this[1]; // xMax
                result[2] = range[2] + this[3]; // yMin
                result[3] = range[3] - this[2]; // yMax
                return result;
            }
            mat3TransformLength(mat, writeTo = this.constructor.factory.createOneEmpty()) {
                writeTo.setLeft(mat.getTransformedXLength(0, this.getLeft()));
                writeTo.setRight(mat.getTransformedXLength(0, this.getRight()));
                writeTo.setTop(mat.getTransformedYLength(0, this.getTop()));
                writeTo.setBottom(mat.getTransformedYLength(0, this.getBottom()));
                return writeTo;
            }
        },
        _a.factory = new mat2_factory_js_1.Mat2Factory(_a, normalized_data_view_provider_js_1.NormalizedDataViewProvider.getView(ctor)),
        _a.rangeCtor = range2d_js_1.Range2d.getCtor(ctor),
        _a;
}
exports.getMargin2dCtor = getMargin2dCtor;
//# sourceMappingURL=get-margin2d-ctor.js.map