import { ITypedArrayTupleFactory } from "../i-typed-array-tuple-factory.js";
import { ATypedTupleFactory } from "../a-typed-tuple-factory.js";
import { TTypedArray } from "../t-typed-array.js";
import { INormalizedDataView } from "../normalized-data-view/i-normalized-data-view.js";
import { IMat2Ctor, Mat2, TMat2CtorArgs } from "./mat2.js";
export declare class Mat2Factory<T extends Mat2<TTypedArray>> extends ATypedTupleFactory<T, TMat2CtorArgs> implements ITypedArrayTupleFactory<T, TMat2CtorArgs> {
    private readonly ctor;
    constructor(ctor: IMat2Ctor<TTypedArray>, dataView: INormalizedDataView);
    createOne(c1r1: number, c1r2: number, c2r1: number, c2r2: number): T;
    createOneEmpty(): T;
    copyFromBuffer(memoryDataView: DataView, pointer: number, writeTo?: T, littleEndian?: boolean): T;
    copyToBuffer(memoryDataView: DataView, writeFrom: Readonly<T>, pointer: number, littleEndian?: boolean): void;
}
