"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Int32DataView = void 0;
const is_little_endian_js_1 = require("../../../web-assembly/util/is-little-endian.js");
class Int32DataView {
    getValue(dataView, ptr, littleEndian = Int32DataView.littleEndian) {
        return dataView.getInt32(ptr, littleEndian);
    }
    setValue(dataView, ptr, value, littleEndian = Int32DataView.littleEndian) {
        dataView.setInt32(ptr, value, littleEndian);
    }
}
exports.Int32DataView = Int32DataView;
Int32DataView.littleEndian = is_little_endian_js_1.isLittleEndian;
//# sourceMappingURL=int32-data-view.js.map