"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NormalizedDataViewProvider = void 0;
const float64_data_view_js_1 = require("./float64-data-view.js");
const float32_data_view_js_1 = require("./float32-data-view.js");
const int32_data_view_js_1 = require("./int32-data-view.js");
const uint32_data_view_js_1 = require("./uint32-data-view.js");
const int16_data_view_js_1 = require("./int16-data-view.js");
const uint16_data_view_js_1 = require("./uint16-data-view.js");
const int8_data_view_js_1 = require("./int8-data-view.js");
const uint8_data_view_js_1 = require("./uint8-data-view.js");
const uint8_clamped_data_view_js_1 = require("./uint8-clamped-data-view.js");
/**
 * @public
 * Provides {@link INormalizedDataView}.
 */
class NormalizedDataViewProvider {
    static getView(typedArrayCtor) {
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return NormalizedDataViewProvider.views.get(typedArrayCtor);
    }
    constructor() {
    }
}
exports.NormalizedDataViewProvider = NormalizedDataViewProvider;
NormalizedDataViewProvider.views = new Map([
    [Float64Array, new float64_data_view_js_1.Float64DataView()],
    [Float32Array, new float32_data_view_js_1.Float32DataView()],
    [Int32Array, new int32_data_view_js_1.Int32DataView()],
    [Uint32Array, new uint32_data_view_js_1.Uint32DataView()],
    [Int16Array, new int16_data_view_js_1.Int16DataView()],
    [Uint16Array, new uint16_data_view_js_1.Uint16DataView()],
    [Int8Array, new int8_data_view_js_1.Int8DataView()],
    [Uint8Array, new uint8_data_view_js_1.Uint8DataView()],
    [Uint8ClampedArray, new uint8_clamped_data_view_js_1.Uint8ClampedDataView()],
]);
//# sourceMappingURL=normalized-data-view-provider.js.map