"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Range1d = void 0;
const get_range1d_ctor_js_1 = require("./get-range1d-ctor.js");
const populate_typed_array_constructor_map_js_1 = require("../../populate-typed-array-constructor-map.js");
const vec2_js_1 = require("../vec2.js");
/**
 * @public
 * Vec2 representing a 1d range.
 *
 * @remarks
 * See static properties for constructors. Instances are not an extension of this class, but of the static members.
 */
class Range1d extends vec2_js_1.Vec2 {
    static getCtor(ctor) {
        return Range1d.constructors.get(ctor);
    }
    setMin(_value) {
        throw new Error();
    }
    setMax(_value) {
        throw new Error();
    }
    getMin() {
        throw new Error();
    }
    getMax() {
        throw new Error();
    }
    getRange() {
        throw new Error();
    }
    getCenter() {
        throw new Error();
    }
    mat2Multiply(_mat, _writeTo) {
        throw new Error();
    }
    unionRange(_range, _writeTo) {
        throw new Error();
    }
    extendRange(_value, _writeTo) {
        throw new Error();
    }
    /**
     * Creates a transform matrix that maps values in this range onto `_toRange`.
     */
    getRangeTransform(_toRange, _result) {
        throw new Error();
    }
    isValueInRange1d(_value) {
        throw new Error();
    }
    /* eslint-disable no-irregular-whitespace */
    /**
     * Scales the range relative to a point (may not be outside of the range).
     *
     * @remarks
     * If the point is at a boundary, then the range will be scaled such that that boundary is not changed. Where the
     * point is away from a boundary, the updated range will have boundaries proportional to the distance from the center
     * of the range.
     *
     * E.g. scaling factor of 0.5, P represents the position of the point in the range:
     *```
     *  min                       max
     *  |P-------------------------|
     *  |-------------|
     *
     *  |------------P-------------|
     *        |-------------|
     *```
     */
    /* eslint-enable no-irregular-whitespace */
    scaleRelativeTo(_scalingFactor, _relativeTo, _result) {
        throw new Error();
    }
    /**
     * Bound this range to the argument.
     *
     * @remarks
     * Where this range is larger than the bounding range, it will be resized to fit.
     * Where this range is smaller than the bounding range but not contained, it will be moved maintaining its size. It
     * Will be moved such that the the side furthest from the bounding range will be at the edge of the boundary.
     */
    bound1d(_boundTo) {
        throw new Error();
    }
    /**
     * Shifts the range by dv.
     */
    translate1d(_dv) {
        throw new Error();
    }
    /**
     * If endianness is not supplied the platform's endianness will be used.
     */
    copyFromBuffer(_memoryDataView, _pointer, _littleEndian) {
        throw new Error();
    }
    /**
     * If endianness is not supplied the platform's endianness will be used.
     */
    copyToBuffer(_memoryDataView, _pointer, _littleEndian) {
        throw new Error();
    }
    /**
     * Although the typed array tuples extend a typed array, they are not structurally compatible.
     * This function returns the argument passed without modification but cast as the underlying storage type, e.g. Float32Array.
     */
    castToBaseType() {
        throw new Error();
    }
}
exports.Range1d = Range1d;
Range1d.f64 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Float64Array);
Range1d.f32 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Float32Array);
Range1d.u32 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Uint32Array);
Range1d.i32 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Int32Array);
Range1d.u16 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Uint16Array);
Range1d.i16 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Int16Array);
Range1d.u8c = (0, get_range1d_ctor_js_1.getRange1dCtor)(Uint8ClampedArray);
Range1d.u8 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Uint8Array);
Range1d.i8 = (0, get_range1d_ctor_js_1.getRange1dCtor)(Int8Array);
Range1d.constructors = (0, populate_typed_array_constructor_map_js_1.populateTypedArrayConstructorMap)(Range1d);
//# sourceMappingURL=range1d.js.map