"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Vec2Factory = void 0;
const a_typed_tuple_factory_js_1 = require("../a-typed-tuple-factory.js");
class Vec2Factory extends a_typed_tuple_factory_js_1.ATypedTupleFactory {
    constructor(ctor, dataView) {
        super(2, ctor.BYTES_PER_ELEMENT, dataView);
        this.ctor = ctor;
    }
    createOneEmpty() {
        return new this.ctor();
    }
    createOne(x, y) {
        const a = this.createOneEmpty();
        a[0] = x;
        a[1] = y;
        return a;
    }
    copyFromBuffer(memoryDataView, pointer, writeTo = this.createOneEmpty(), littleEndian = Vec2Factory.littleEndian) {
        writeTo[0] = this.dataView.getValue(memoryDataView, pointer, littleEndian);
        writeTo[1] = this.dataView.getValue(memoryDataView, pointer += this.bytesPerElement, littleEndian);
        return writeTo;
    }
    copyToBuffer(memoryDataView, writeFrom, pointer, littleEndian = Vec2Factory.littleEndian) {
        this.dataView.setValue(memoryDataView, pointer, writeFrom[0], littleEndian);
        this.dataView.setValue(memoryDataView, pointer += this.bytesPerElement, writeFrom[1], littleEndian);
    }
}
exports.Vec2Factory = Vec2Factory;
//# sourceMappingURL=vec2-factory.js.map