"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getVec3Ctor = void 0;
const vec3_factory_js_1 = require("./vec3-factory.js");
const normalized_data_view_provider_js_1 = require("../normalized-data-view/normalized-data-view-provider.js");
/**
 * @internal
 */
function getVec3Ctor(ctor) {
    var _a;
    return _a = class Vec3Impl extends ctor {
            constructor(bufferOrLength = 3, offset, length) {
                super(bufferOrLength, offset, length);
            }
            isEqualTo(other) {
                return this[0] === other[0] && this[1] === other[1] && this[2] === other[2];
            }
            getX() {
                return this[0];
            }
            getY() {
                return this[1];
            }
            getZ() {
                return this[2];
            }
            getMagnitude() {
                const x = this[0];
                const y = this[1];
                const z = this[2];
                return Math.sqrt(x * x + y * y + z * z);
            }
            getMagnitudeSquared() {
                const x = this[0];
                const y = this[1];
                const z = this[2];
                return x * x + y * y + z * z;
            }
            dotProduct(vec) {
                return this[0] * vec[0] + this[1] * vec[1] + this[2] * vec[2];
            }
            update(x, y, z) {
                this[0] = x;
                this[1] = y;
                this[2] = z;
            }
            setX(x) {
                this[0] = x;
            }
            setY(y) {
                this[1] = y;
            }
            setZ(z) {
                this[2] = z;
            }
            getLoggableValue() {
                return [
                    [this[0], this[1], this[2]],
                ];
            }
            copyFromBuffer(memoryDataView, pointer, littleEndian) {
                this.constructor.factory.copyFromBuffer(memoryDataView, pointer, this, littleEndian);
            }
            copyToBuffer(memoryDataView, pointer, littleEndian) {
                this.constructor.factory.copyToBuffer(memoryDataView, this, pointer, littleEndian);
            }
            castToBaseType() {
                return this;
            }
        },
        _a.factory = new vec3_factory_js_1.Vec3Factory(_a, normalized_data_view_provider_js_1.NormalizedDataViewProvider.getView(ctor)),
        _a;
}
exports.getVec3Ctor = getVec3Ctor;
//# sourceMappingURL=get-vec3-ctor.js.map