"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getVec4Ctor = void 0;
const vec4_factory_js_1 = require("./vec4-factory.js");
const normalized_data_view_provider_js_1 = require("../normalized-data-view/normalized-data-view-provider.js");
const rgba_color_packer_js_1 = require("../../../colors/rgba-color-packer.js");
/**
 * @internal
 */
function getVec4Ctor(ctor) {
    var _a;
    return _a = class Vec4Impl extends ctor {
            constructor(bufferOrLength = 4, offset, length) {
                super(bufferOrLength, offset, length);
            }
            isEqualTo(other) {
                return this[0] === other[0] && this[1] === other[1] && this[2] === other[2] && this[3] === other[3];
            }
            setRGBAColor(packedRGBA, normalize = false) {
                if (normalize) {
                    // 1 / 255
                    this[0] = rgba_color_packer_js_1.RgbaColorPacker.unpackR(packedRGBA) * 0.00392156862745098;
                    this[1] = rgba_color_packer_js_1.RgbaColorPacker.unpackG(packedRGBA) * 0.00392156862745098;
                    this[2] = rgba_color_packer_js_1.RgbaColorPacker.unpackB(packedRGBA) * 0.00392156862745098;
                    this[3] = rgba_color_packer_js_1.RgbaColorPacker.unpackA(packedRGBA) * 0.00392156862745098;
                }
                else {
                    this[0] = rgba_color_packer_js_1.RgbaColorPacker.unpackR(packedRGBA);
                    this[1] = rgba_color_packer_js_1.RgbaColorPacker.unpackG(packedRGBA);
                    this[2] = rgba_color_packer_js_1.RgbaColorPacker.unpackB(packedRGBA);
                    this[3] = rgba_color_packer_js_1.RgbaColorPacker.unpackA(packedRGBA);
                }
                return this;
            }
            /**
             * @param normalized - Is the data normalized (i.e. ranges from 0 - 1)? If so it will be multiplied up by 255.
             */
            getPackedRGBAColor(normalized = false) {
                if (normalized) {
                    return rgba_color_packer_js_1.RgbaColorPacker.packColor(this[0] * 255, this[1] * 255, this[2] * 255, this[3] * 255);
                }
                else {
                    return rgba_color_packer_js_1.RgbaColorPacker.packColor(this[0], this[1], this[2], this[3]);
                }
            }
            getX() {
                return this[0];
            }
            getY() {
                return this[1];
            }
            getZ() {
                return this[2];
            }
            getW() {
                return this[3];
            }
            update(x, y, z, w) {
                this[0] = x;
                this[1] = y;
                this[2] = z;
                this[3] = w;
            }
            setX(x) {
                this[0] = x;
            }
            setY(y) {
                this[1] = y;
            }
            setZ(z) {
                this[2] = z;
            }
            setW(w) {
                this[3] = w;
            }
            getLoggableValue() {
                return [
                    [this[0], this[1], this[2]],
                ];
            }
            copyFromBuffer(memoryDataView, pointer, littleEndian) {
                this.constructor.factory.copyFromBuffer(memoryDataView, pointer, this, littleEndian);
            }
            copyToBuffer(memoryDataView, pointer, littleEndian) {
                this.constructor.factory.copyToBuffer(memoryDataView, this, pointer, littleEndian);
            }
            castToBaseType() {
                return this;
            }
        },
        _a.factory = new vec4_factory_js_1.Vec4Factory(_a, normalized_data_view_provider_js_1.NormalizedDataViewProvider.getView(ctor)),
        _a.elementCount = 4,
        _a;
}
exports.getVec4Ctor = getVec4Ctor;
//# sourceMappingURL=get-vec4-ctor.js.map