"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ERgbaMasks = exports.ERgbaShift = void 0;
/**
 * @public
 * Bit offset for packed RGBA colors.
 *
 * @remarks
 * After masking zero fill right shift to unpack.
 * Left shift to pack (0-255 as input).
 * Stored as ABGR to allow packing of RGB into float32.
 */
var ERgbaShift;
(function (ERgbaShift) {
    ERgbaShift[ERgbaShift["R"] = 0] = "R";
    ERgbaShift[ERgbaShift["G"] = 8] = "G";
    ERgbaShift[ERgbaShift["B"] = 16] = "B";
    ERgbaShift[ERgbaShift["A"] = 24] = "A";
})(ERgbaShift = exports.ERgbaShift || (exports.ERgbaShift = {}));
/**
 * @public
 * Bit mask for packed RGBA colors.
 */
var ERgbaMasks;
(function (ERgbaMasks) {
    ERgbaMasks[ERgbaMasks["R"] = 255] = "R";
    ERgbaMasks[ERgbaMasks["G"] = 65280] = "G";
    ERgbaMasks[ERgbaMasks["B"] = 16711680] = "B";
    ERgbaMasks[ERgbaMasks["A"] = -16777216] = "A";
})(ERgbaMasks = exports.ERgbaMasks || (exports.ERgbaMasks = {}));
//# sourceMappingURL=e-rgba-masks.js.map