"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugPointer = void 0;
const _debug_js_1 = require("./_debug.js");
const number_get_hex_string_js_1 = require("../number/impl/number-get-hex-string.js");
const array_insert_at_index_js_1 = require("../array/impl/array-insert-at-index.js");
class DebugPointer {
    constructor(pointer, objectConstructor, isStatic, instanceLabel = _debug_js_1._Debug.label) {
        this.pointer = pointer;
        this.objectConstructor = objectConstructor;
        this.isStatic = isStatic;
        this.instanceLabel = instanceLabel;
        this.creationCallstack = _debug_js_1._Debug.getStackTrace();
    }
    toString() {
        const lines = [
            `WASM address: ${(0, number_get_hex_string_js_1.numberGetHexString)(this.pointer)}`,
            `Js constructor name: ${this.objectConstructor.name}`,
            "\nCall site stack trace follows:",
            this.creationCallstack,
        ];
        if (this.instanceLabel != null) {
            (0, array_insert_at_index_js_1.arrayInsertAtIndex)(lines, `Instance label : ${this.instanceLabel}`, 2);
        }
        return lines.join("\n");
    }
}
exports.DebugPointer = DebugPointer;
//# sourceMappingURL=debug-pointer.js.map