import { TListener } from "../eventing/t-listener.js";
import { TDebugListener } from "./t-debug-listener.js";
/**
 * @public
 * Like {@link IBroadcastEvent} but without holding strong references. Available in debug contexts only.
 */
export interface IDebugWeakBroadcastEvent<K extends string, TArgs extends unknown[]> {
    addListener(listener: TDebugListener<K, TArgs>): void;
    addTemporaryListener(listener: TDebugListener<K, TArgs>): () => void;
    removeListener(listener: TDebugListener<K, TArgs>): void;
    emit(...args: TArgs): void;
}
export declare class DebugWeakBroadcastEvent<TKey extends string, TArgs extends unknown[]> implements IDebugWeakBroadcastEvent<TKey, TArgs> {
    private readonly key;
    constructor(key: TKey);
    addListener(listener: TListener<TKey, TArgs>): void;
    addTemporaryListener(listener: TListener<TKey, TArgs>): () => void;
    addOneTimeListener(listener: TListener<TKey, TArgs>): () => void;
    emit(...args: TArgs): void;
    removeListener(listener: TListener<TKey, TArgs>): void;
    getTargets(): readonly TListener<TKey, TArgs>[];
    private readonly listenersSet;
    private readonly listenersMap;
}
