"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugWeakValue = void 0;
const _debug_js_1 = require("./_debug.js");
class DebugWeakValue {
    constructor(values = new WeakMap()) {
        this.values = values;
    }
    setValue(listener, value) {
        this.values.set(listener, value);
    }
    deleteValue(listener) {
        this.values.delete(listener);
    }
    getValue(listener) {
        _BUILD.DEBUG && _debug_js_1._Debug.assert(this.values.has(listener), "expected to find value");
        return this.values.get(listener);
    }
}
exports.DebugWeakValue = DebugWeakValue;
//# sourceMappingURL=debug-weak-value.js.map