"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dictionaryForEach = void 0;
/**
 * @public
 * Like `Array.forEach` but for arbitrary objects.
 *
 * @remarks
 * See {@link dictionaryForEach}.
 */
function dictionaryForEach(dictionary, callback) {
    const keys = Object.keys(dictionary);
    for (let i = 0, iEnd = keys.length; i < iEnd; ++i) {
        const key = keys[i];
        callback(dictionary[key], key, dictionary);
    }
}
exports.dictionaryForEach = dictionaryForEach;
//# sourceMappingURL=dictionary-foreach.js.map