"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dictionaryPush = void 0;
/**
 * @public
 * Used with dictionary that store arrays. Where an array exists for a given key the value will be appended to that array, otherwise a new array will be created containing the value.
 * @param dict - The object to check. May be modified.
 * @param key - The key to lookup in `dict`.
 * @param value - The value to push.
 * @remarks
 * See {@link dictionaryPush}.
 */
function dictionaryPush(dict, key, value) {
    const values = dict[key];
    if (values != null) {
        values.push(value);
    }
    else {
        dict[key] = [value];
    }
}
exports.dictionaryPush = dictionaryPush;
//# sourceMappingURL=dictionary-push.js.map