import { TListener } from "./t-listener.js";
import { IBroadcastEvent } from "./i-broadcast-event.js";
/**
 * @public
 * Strong reference implementation of {@link IBroadcastEvent}.
 */
export declare class BroadcastEvent<TKey extends string, TArgs extends unknown[]> implements IBroadcastEvent<TKey, TArgs> {
    private key;
    constructor(key: TKey);
    addListener(listener: TListener<TKey, TArgs>): void;
    addTemporaryListener(listener: TListener<TKey, TArgs>): () => void;
    addOneTimeListener(listener: TListener<TKey, TArgs>): () => void;
    removeListener(listener: TListener<TKey, TArgs>): void;
    emit(...args: TArgs): void;
    getTargets(): readonly TListener<TKey, TArgs>[];
    private readonly listeners;
    private cache;
}
