import { fpIdentity } from "./impl/fp-identity.js";
import { fpNormalizeToNull } from "./impl/fp-normalize-to-null.js";
import { fpNormalizeToUndefined } from "./impl/fp-normalize-to-undefined.js";
import { fpOnce } from "./impl/fp-once.js";
import { fpNoOp } from "./impl/fp-no-op.js";
import { fpValueOrNull } from "./impl/fp-value-or-null.js";
import { fpMaybeNewValue } from "./impl/fp-maybe-new-value.js";
import { fpDebounce } from "./impl/fp-debounce.js";
/**
 * @public
 * Utilities for functional programming.
 */
export declare class _Fp {
    /** {@inheritDoc fpDebounce} */
    static readonly debounce: typeof fpDebounce;
    /** {@inheritDoc fpIdentity} */
    static readonly identity: typeof fpIdentity;
    /** {@inheritDoc fpMaybeNewValue} */
    static readonly maybeNewValue: typeof fpMaybeNewValue;
    /** {@inheritDoc fpNoOp} */
    static readonly noOp: typeof fpNoOp;
    /** {@inheritDoc fpNormalizeToNull} */
    static readonly normalizeToNull: typeof fpNormalizeToNull;
    /** {@inheritDoc fpNormalizeToUndefined} */
    static readonly normalizeToUndefined: typeof fpNormalizeToUndefined;
    /** {@inheritDoc fpOnce} */
    static readonly once: typeof fpOnce;
    /** {@inheritDoc fpValueOrNull} */
    static readonly valueOrNull: typeof fpValueOrNull;
    private constructor();
}
