"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fpOnce = void 0;
/**
 * @public
 * Creates a function that can be called many times but will run at most once.
 *
 * @remarks
 * See {@link fpOnce}.
 */
function fpOnce(initialize) {
    let item;
    let initialized = false;
    return (...args) => {
        if (initialized) {
            return item;
        }
        initialized = true;
        return item = initialize(...args);
    };
}
exports.fpOnce = fpOnce;
//# sourceMappingURL=fp-once.js.map