"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReferenceCountedOwner = void 0;
const a_reference_counted_js_1 = require("./a-reference-counted.js");
const lifecycle_stack_js_1 = require("../web-assembly/emscripten/lifecycle-stack.js");
/**
 * @public
 * A reference counted object
 */
class ReferenceCountedOwner extends a_reference_counted_js_1.AReferenceCounted {
    /**
     * Creates a ReferenceCountedOwner bound to `bindToReference`. By default, block scoped is disabled.
     */
    static createOneBound(bindToReference, blockScoped = false) {
        const ref = new ReferenceCountedOwner(blockScoped);
        bindToReference.linkRef(ref);
        if (!blockScoped) {
            ref.release();
        }
        return ref;
    }
    constructor(blockScoped = true) {
        super();
        if (blockScoped) {
            lifecycle_stack_js_1.lifecycleStack.register(this);
        }
    }
}
exports.ReferenceCountedOwner = ReferenceCountedOwner;
//# sourceMappingURL=reference-counted-owner.js.map