"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TemporaryListener = void 0;
const dirty_checked_unique_collection_js_1 = require("../collection/dirty-checked-unique-collection.js");
/**
 * @public
 * {@inheritDoc ITemporaryListener}
 */
class TemporaryListener {
    constructor() {
        this.listeners = new dirty_checked_unique_collection_js_1.DirtyCheckedUniqueCollection();
    }
    clearingEmit(...args) {
        this.emit(...args);
        this.clearListeners();
    }
    emit(...args) {
        const listenerCallback = this.listeners.getArray();
        for (let i = 0, iEnd = listenerCallback.length; i < iEnd; ++i) {
            listenerCallback[i](...args);
        }
    }
    clearListeners() {
        this.listeners.clear();
    }
    initializeListener(callback) {
        this.listeners.add(callback());
    }
    addListener(listener) {
        this.listeners.add(listener);
    }
    removeListener(listener) {
        this.listeners.delete(listener);
    }
    getTargets() {
        return this.listeners.getArray();
    }
}
exports.TemporaryListener = TemporaryListener;
//# sourceMappingURL=temporary-listener.js.map