import { mapArrayMap } from "./impl/map-array-map.js";
import { mapFirstKey } from "./impl/map-first-key.js";
import { mapFirstValue } from "./impl/map-first-value.js";
import { mapInitializeGet } from "./impl/map-intialize-get.js";
import { mapKeysToArray } from "./impl/map-keys-to-array.js";
import { mapPush } from "./impl/map-push.js";
import { mapValuesToArray } from "./impl/map-values-to-array.js";
import { mapEntriesToArray } from "./impl/map-entries-to-array.js";
import { mapDeleteGet } from "./impl/map-delete-get.js";
import { mapAddToSet } from "./impl/map-add-to-set.js";
import { mapDeleteFromSet } from "./impl/map-delete-from-set.js";
import { mapReportingAddToSet } from "./impl/map-reporting-add-to-set.js";
import { mapRemoveManyFromArray } from "./impl/map-remove-many-from-array.js";
import { mapRemoveOneFromArray } from "./impl/map-remove-one-from-array.js";
import { mapSetDifference } from "./impl/map-set-difference.js";
import { mapSymmetricDifference } from "./impl/map-symmetric-difference.js";
import { mapUnion } from "./impl/map-union.js";
import { mapIntersect } from "./impl/map-intersect.js";
import { mapConcat } from "./impl/map-concat.js";
import { mapClearingDeleteFromSet } from "./impl/map-clearing-delete-from-set.js";
/**
 * @public
 * Utilities that apply to `Map`.
 */
export declare class _Map {
    /** {@inheritDoc (mapAddToSet: 1)} */
    static readonly addToSet: typeof mapAddToSet;
    /** {@inheritDoc mapArrayMap} */
    static readonly arrayMap: typeof mapArrayMap;
    /** {@inheritDoc (mapConcat: 1)} */
    static readonly concat: typeof mapConcat;
    /** {@inheritDoc (mapDeleteFromSet: 1)} */
    static readonly deleteFromSet: typeof mapDeleteFromSet;
    /** {@inheritDoc (mapDeleteGet: 1)} */
    static readonly deleteGet: typeof mapDeleteGet;
    /** {@inheritDoc (mapClearingDeleteFromSet: 1)} */
    static readonly clearingDeleteFromSet: typeof mapClearingDeleteFromSet;
    /** {@inheritDoc mapEntriesToArray} */
    static readonly entriesToArray: typeof mapEntriesToArray;
    /** {@inheritDoc mapFirstKey} */
    static readonly firstKey: typeof mapFirstKey;
    /** {@inheritDoc mapFirstValue} */
    static readonly firstValue: typeof mapFirstValue;
    /** {@inheritDoc mapIntersect} */
    static readonly intersect: typeof mapIntersect;
    /** {@inheritDoc (mapInitializeGet:1)} */
    static readonly initializeGet: typeof mapInitializeGet;
    /** {@inheritDoc mapKeysToArray} */
    static readonly keysToArray: typeof mapKeysToArray;
    /** {@inheritDoc (mapPush: 1)} */
    static readonly push: typeof mapPush;
    /** {@inheritDoc (mapReportingAddToSet: 1)} */
    static readonly removeManyFromArray: typeof mapRemoveManyFromArray;
    /** {@inheritDoc (mapRemoveOneFromArray: 1)} */
    static readonly removeOneFromArray: typeof mapRemoveOneFromArray;
    /** {@inheritDoc (mapReportingAddToSet: 1)} */
    static readonly reportingAddToSet: typeof mapReportingAddToSet;
    /** {@inheritDoc mapSetDifference} */
    static readonly setDifference: typeof mapSetDifference;
    /** {@inheritDoc mapSymmetricDifference} */
    static readonly symmetricDifference: typeof mapSymmetricDifference;
    /** {@inheritDoc mapUnion} */
    static readonly union: typeof mapUnion;
    /** {@inheritDoc mapValuesToArray} */
    static readonly valuesToArray: typeof mapValuesToArray;
    private constructor();
}
