import { mathMin } from "./impl/math-min.js";
import { mathMax } from "./impl/math-max.js";
import { mathBound } from "./impl/math-bound.js";
import { mathBoundRandom } from "./impl/math-bound-random.js";
import { mathHypot2 } from "./impl/math-hypot.js";
/**
 * @public
 * Utilities relating to math.
 */
export declare class _Math {
    /** {@inheritDoc mathBound} */
    static readonly bound: typeof mathBound;
    /** {@inheritDoc mathBoundRandom} */
    static readonly boundRandom: typeof mathBoundRandom;
    /** {@inheritDoc mathHypot2} */
    static readonly hypot2: typeof mathHypot2;
    /** {@inheritDoc mathMin} */
    static readonly min: typeof mathMin;
    /** {@inheritDoc mathMax} */
    static readonly max: typeof mathMax;
    private constructor();
}
