"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mathMax = void 0;
const _debug_js_1 = require("../../debug/_debug.js");
/**
 * @public
 * Returns the larger of the two parameters `a` and `b`.
 *
 * @remarks
 * NaN input will cause a debug error.
 * Differs from Math.max by taking only 2 arguments, avoids overhead of handling variable number of arguments.
 *
 * See {@link mathMax}.
 */
function mathMax(a, b) {
    _BUILD.DEBUG && _debug_js_1._Debug.runBlock(() => {
        _debug_js_1._Debug.assert(!isNaN(a), "expected a to be a number");
        _debug_js_1._Debug.assert(!isNaN(b), "expected b to be a number");
    });
    if (a > b) {
        return a;
    }
    return b;
}
exports.mathMax = mathMax;
//# sourceMappingURL=math-max.js.map