"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.promiseDelay = void 0;
/**
 * @public
 * Returns a `Promise` which will resolve to `resolveWith` after a delay of `delay` (in milliseconds).
 *
 * @remarks
 * See {@link promiseDelay}.
 */
function promiseDelay(resolveWith, delay = 4) {
    return new Promise((done) => {
        setTimeout(() => {
            done(resolveWith);
        }, delay);
    });
}
exports.promiseDelay = promiseDelay;
//# sourceMappingURL=promise-delay.js.map