"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.promiseRejectFalse = void 0;
const tslib_1 = require("tslib");
/**
 * @public
 * Returns a Promise of rejection with the supplied error if the `value` is false.
 *
 * @remarks
 * See {@link promiseRejectFalse}.
 */
function promiseRejectFalse(value, error) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const result = yield value;
        if (result === false) {
            return Promise.reject(error);
        }
    });
}
exports.promiseRejectFalse = promiseRejectFalse;
//# sourceMappingURL=promise-reject-false.js.map