"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.promiseRejectFalsey = void 0;
const tslib_1 = require("tslib");
/**
 * @public
 * Returns a Promise of rejection with the supplied error if the `value` is falsy.
 *
 * @remarks
 * See {@link promiseRejectFalsey}.
 */
function promiseRejectFalsey(value, error) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const result = yield value;
        if (!result) {
            return Promise.reject(error);
        }
    });
}
exports.promiseRejectFalsey = promiseRejectFalsey;
//# sourceMappingURL=promise-reject-falsey.js.map