"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lifecycleStack = exports.LifecycleStack = void 0;
const _debug_js_1 = require("../../debug/_debug.js");
const _production_js_1 = require("../../production/_production.js");
const get_global_js_1 = require("../../runtime/get-global.js");
/**
 * @public
 */
class LifecycleStack {
    constructor() {
        var _a;
        var _b;
        this.allocationStack = ((_a = (_b = (0, get_global_js_1.getGlobal)())["RC_ALLOCATION_STACK"]) !== null && _a !== void 0 ? _a : (_b["RC_ALLOCATION_STACK"] = []));
    }
    push() {
        const top = [];
        this.allocationStack.push(top);
        return top;
    }
    pop() {
        _BUILD.DEBUG && _debug_js_1._Debug.assert(this.allocationStack.length > 0, "attempted to pop empty stack");
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return this.allocationStack.pop();
    }
    register(ref) {
        const top = this.allocationStack[this.allocationStack.length - 1];
        if (top == null) {
            throw _production_js_1._Production.createError("attempted to create shared lifecycle object outside of allocation scope.");
        }
        top.push(ref);
    }
    getSize() {
        return this.allocationStack.length;
    }
}
exports.LifecycleStack = LifecycleStack;
/**
 * @public
 */
exports.lifecycleStack = new LifecycleStack();
//# sourceMappingURL=lifecycle-stack.js.map