import { arrayBinaryIndexOf } from "./impl/array-binary-index-of.js";
import { arrayIsArray } from "./impl/array-is-array.js";
import { arrayBinaryLastIndexOf } from "./impl/array-binary-last-index-of.js";
import { arrayMap } from "./impl/array-map.js";
import { arrayCopyInto } from "./impl/array-copy-into.js";
import { arrayFlatMap } from "./impl/array-flat-map.js";
import { arrayForEach } from "./impl/array-for-each.js";
import { arrayIndex } from "./impl/array-index.js";
import { arrayIntersect } from "./impl/array-intersect.js";
import { arrayLast } from "./impl/array-last.js";
import { arrayNormalizeEmptyToUndefined } from "./impl/array-normalize-empty-to-undefined.js";
import { arrayNormalizeNullishToEmpty } from "./impl/array-normalize-nullish-to-empty.js";
import { arrayCollect } from "./impl/array-collect.js";
import { arrayRemoveMany } from "./impl/array-remove-many.js";
import { arrayRemoveOne } from "./impl/array-remove-one.js";
import { arrayReplaceOne } from "./impl/array-replace-one.js";
import { arrayCompact } from "./impl/array-compact.js";
import { arrayCompactMap } from "./impl/array-compact-map.js";
import { arrayUnion } from "./impl/array-union.js";
import { arrayPushUnique } from "./impl/array-push-unique.js";
import { arrayGenerateRange } from "./impl/array-generate-range.js";
import { arrayMapRange } from "./impl/array-map-range.js";
import { arrayContains } from "./impl/array-contains.js";
import { arrayInsertAtIndex } from "./impl/array-insert-at-index.js";
import { arraySymmetricDifference } from "./impl/array-symmetric-difference.js";
import { arraySetDifference } from "./impl/array-set-difference.js";
import { arrayIsNotEmpty } from "./impl/array-is-not-empty.js";
import { arrayUnique } from "./impl/array-unique.js";
import { arrayAddToSet } from "./impl/array-add-to-set.js";
import { arrayForEachRange } from "./impl/array-for-each-range.js";
import { arrayMax } from "./impl/array-max.js";
import { arrayMin } from "./impl/array-min.js";
import { arrayBinaryFindInsertionIndex } from "./impl/array-binary-find-insertion-index.js";
/**
 * @public
 * Utilities that apply to `Array` and `ArrayLike`.
 */
export declare class _Array {
    /** {@inheritDoc arrayAddToSet} */
    static readonly addToSet: typeof arrayAddToSet;
    /** {@inheritDoc arrayBinaryFindInsertionIndex} */
    static readonly binaryFindInsertionIndex: typeof arrayBinaryFindInsertionIndex;
    /** {@inheritDoc arrayBinaryIndexOf} */
    static readonly binaryIndexOf: typeof arrayBinaryIndexOf;
    /** {@inheritDoc arrayBinaryLastIndexOf} */
    static readonly binaryLastIndexOf: typeof arrayBinaryLastIndexOf;
    /** {@inheritDoc arrayCollect} */
    static readonly collect: typeof arrayCollect;
    /** {@inheritDoc arrayCompact} */
    static readonly compact: typeof arrayCompact;
    /** {@inheritDoc arrayCompactMap} */
    static readonly compactMap: typeof arrayCompactMap;
    /** {@inheritDoc (arrayContains:2)} */
    static readonly contains: typeof arrayContains;
    /** {@inheritDoc arrayCopyInto} */
    static readonly copyInto: typeof arrayCopyInto;
    /** {@inheritDoc arrayEmptyArray} */
    static readonly emptyArray: readonly [];
    /** {@inheritDoc arrayFlatMap} */
    static readonly flatMap: typeof arrayFlatMap;
    /** {@inheritDoc arrayForEach} */
    static readonly forEach: typeof arrayForEach;
    /** {@inheritDoc arrayForEachRange} */
    static readonly forEachRange: typeof arrayForEachRange;
    /** {@inheritDoc arrayGenerateRange} */
    static readonly generateRange: typeof arrayGenerateRange;
    /** {@inheritDoc arrayIndex} */
    static readonly index: typeof arrayIndex;
    /** {@inheritDoc arrayInsertAtIndex} */
    static readonly insertAtIndex: typeof arrayInsertAtIndex;
    /** {@inheritDoc arrayIntersect} */
    static readonly intersect: typeof arrayIntersect;
    /** {@inheritDoc arrayIsArray} */
    static readonly isArray: typeof arrayIsArray;
    /** {@inheritDoc arrayIsNotEmpty} */
    static readonly isNotEmpty: typeof arrayIsNotEmpty;
    /** {@inheritDoc arrayLast} */
    static readonly last: typeof arrayLast;
    /** {@inheritDoc arrayMap} */
    static readonly map: typeof arrayMap;
    /** {@inheritDoc arrayMapRange} */
    static readonly mapRange: typeof arrayMapRange;
    /** {@inheritDoc arrayMax} */
    static readonly max: typeof arrayMax;
    /** {@inheritDoc arrayMin} */
    static readonly min: typeof arrayMin;
    /** {@inheritDoc arrayNormalizeEmptyToUndefined} */
    static readonly normalizeEmptyToUndefined: typeof arrayNormalizeEmptyToUndefined;
    /** {@inheritDoc arrayNormalizeNullishToEmpty} */
    static readonly normalizeNullishToEmpty: typeof arrayNormalizeNullishToEmpty;
    /** {@inheritDoc arrayPushUnique} */
    static readonly pushUnique: typeof arrayPushUnique;
    /** {@inheritDoc arrayRemoveMany} */
    static readonly removeMany: typeof arrayRemoveMany;
    /** {@inheritDoc arrayRemoveOne} */
    static readonly removeOne: typeof arrayRemoveOne;
    /** {@inheritDoc arrayReplaceOne} */
    static readonly replaceOne: typeof arrayReplaceOne;
    /** {@inheritDoc arraySetDifference} */
    static readonly setDifference: typeof arraySetDifference;
    /** {@inheritDoc arraySymmetricDifference} */
    static readonly symmetricDifference: typeof arraySymmetricDifference;
    /** {@inheritDoc arrayUnion} */
    static readonly union: typeof arrayUnion;
    /** {@inheritDoc arrayUnique} */
    static readonly unique: typeof arrayUnique;
    private constructor();
}
