/**
 * @public
 * Like _Array.map but where the callback returns null it will be omitted from the result.
 *
 * @remarks
 * See {@link arrayCompactMap}.
 */
export declare function arrayCompactMap<TItem, TTransformed>(items: ArrayLike<TItem>, map: (item: TItem, index: number) => TTransformed | null): TTransformed[];
