/**
 * @public
 * Strips null and undefined items from arrays (non mutative).
 *
 * @remarks
 * See {@link arrayCompact}.
 */
export function arrayCompact(items) {
    const result = [];
    for (let i = 0, iEnd = items.length; i < iEnd; ++i) {
        const item = items[i];
        if (item != null) {
            result.push(item);
        }
    }
    return result;
}
//# sourceMappingURL=array-compact.js.map