/**
 * @public
 * Like {@link arrayForEach} with integer range as input.
 *
 * @param from - The value to start from (inclusive).
 * @param to - The value to finish with (inclusive).
 * @param callback - Called for each value in the range.
 *
 * @remarks
 * Where `from` and `to` are equal a length 1 array is returned, NaN input is not supported.
 *
 * See {@link arrayForEachRange}.
 */
export declare function arrayForEachRange(from: number, to: number, callback: (value: number, index: number) => void): void;
