import { getMargin2dCtor } from "./get-margin2d-ctor.js";
import { populateTypedArrayConstructorMap } from "../../populate-typed-array-constructor-map.js";
import { Mat2 } from "../../mat2/mat2.js";
/**
 * @public
 * 2x2 matrix representing margins on a rectangle.
 *
 * @remarks
 * See static properties for constructors. Instances are not an extension of this class, but of the static members.
 */
export class Margin2d extends Mat2 {
    static getCtor(ctor) {
        return this.constructors.get(ctor);
    }
    getLeft() {
        throw new Error();
    }
    getRight() {
        throw new Error();
    }
    getTop() {
        throw new Error();
    }
    getBottom() {
        throw new Error();
    }
    setLeft(_value) {
        throw new Error();
    }
    setRight(_value) {
        throw new Error();
    }
    setTop(_value) {
        throw new Error();
    }
    setBottom(_value) {
        throw new Error();
    }
    update(..._args) {
        throw new Error();
    }
    sumX() {
        throw new Error();
    }
    sumY() {
        throw new Error();
    }
    getInnerRange(_range, _result) {
        throw new Error();
    }
    /**
     * Applies `Mat3.getTransformedXLength` `Mat3.getTransformedYLength` with a minimum of 0 and a maximum of
     * whatever the margin is.
     */
    mat3TransformLength(_mat, _writeTo) {
        throw new Error();
    }
    /**
     * If endianness is not supplied the platform's endianness will be used.
     */
    copyFromBuffer(_memoryDataView, _pointer, _littleEndian) {
        throw new Error();
    }
    /**
     * If endianness is not supplied the platform's endianness will be used.
     */
    copyToBuffer(_memoryDataView, _pointer, _littleEndian) {
        throw new Error();
    }
    /**
     * Although the typed array tuples extend a typed array, they are not structurally compatible.
     * This function returns the argument passed without modification but cast as the underlying storage type, e.g. Float32Array.
     */
    castToBaseType() {
        throw new Error();
    }
}
Margin2d.f64 = getMargin2dCtor(Float64Array);
Margin2d.f32 = getMargin2dCtor(Float32Array);
Margin2d.u32 = getMargin2dCtor(Uint32Array);
Margin2d.i32 = getMargin2dCtor(Int32Array);
Margin2d.u16 = getMargin2dCtor(Uint16Array);
Margin2d.i16 = getMargin2dCtor(Int16Array);
Margin2d.u8c = getMargin2dCtor(Uint8ClampedArray);
Margin2d.u8 = getMargin2dCtor(Uint8Array);
Margin2d.i8 = getMargin2dCtor(Int8Array);
Margin2d.constructors = populateTypedArrayConstructorMap(Margin2d);
//# sourceMappingURL=margin2d.js.map