/**
 * @internal
 */
export function populateTypedArrayConstructorMap(constructors) {
    const m = new Map();
    m.set(Float64Array, constructors.f64);
    m.set(Float32Array, constructors.f32);
    m.set(Int32Array, constructors.i32);
    m.set(Uint32Array, constructors.u32);
    m.set(Int16Array, constructors.i16);
    m.set(Uint16Array, constructors.u16);
    m.set(Int8Array, constructors.i8);
    m.set(Uint8Array, constructors.u8);
    m.set(Uint8ClampedArray, constructors.u8c);
    return m;
}
//# sourceMappingURL=populate-typed-array-constructor-map.js.map