import { SharedMemoryBlock } from "../../web-assembly/shared-memory/shared-memory-block.js";
import { isLittleEndian } from "../../web-assembly/util/is-little-endian.js";
/**
 @public
 {@inheritDoc ISharedTypedArrayTuple}
 */
export class SharedTypedArrayTuple {
    static createOne(typedArrayCtor, bindToReference, wrapper) {
        const byteSize = typedArrayCtor.BYTES_PER_ELEMENT * typedArrayCtor.factory.elementCount;
        const block = SharedMemoryBlock.createOne(wrapper, bindToReference, byteSize);
        return new SharedTypedArrayTuple(block);
    }
    copyToBuffer(readFrom) {
        readFrom.copyToBuffer(this.memory.getDataView(), 0, SharedTypedArrayTuple.littleEndian);
    }
    copyFromBuffer(writeTo) {
        writeTo.copyFromBuffer(this.memory.getDataView(), 0, SharedTypedArrayTuple.littleEndian);
    }
    constructor(memory) {
        this.memory = memory;
        this.sharedObject = memory.sharedObject;
    }
}
SharedTypedArrayTuple.littleEndian = isLittleEndian;
//# sourceMappingURL=shared-typed-array-tuple.js.map