import { ITypedArrayTupleFactory } from "../i-typed-array-tuple-factory.js";
import { IVec2Ctor, TVec2CtorArgs, Vec2 } from "./vec2.js";
import { ATypedTupleFactory } from "../a-typed-tuple-factory.js";
import { TTypedArray } from "../t-typed-array.js";
import { INormalizedDataView } from "../normalized-data-view/i-normalized-data-view.js";
export declare class Vec2Factory<T extends Vec2<TTypedArray>> extends ATypedTupleFactory<T, TVec2CtorArgs> implements ITypedArrayTupleFactory<T, TVec2CtorArgs> {
    private ctor;
    constructor(ctor: IVec2Ctor<TTypedArray>, dataView: INormalizedDataView);
    createOneEmpty(): T;
    createOne(x: number, y: number): T;
    copyFromBuffer(memoryDataView: DataView, pointer: number, writeTo?: T, littleEndian?: boolean): T;
    copyToBuffer(memoryDataView: DataView, writeFrom: Readonly<T>, pointer: number, littleEndian?: boolean): void;
}
