import { ATypedTupleFactory } from "../a-typed-tuple-factory.js";
export class Vec2Factory extends ATypedTupleFactory {
    constructor(ctor, dataView) {
        super(2, ctor.BYTES_PER_ELEMENT, dataView);
        this.ctor = ctor;
    }
    createOneEmpty() {
        return new this.ctor();
    }
    createOne(x, y) {
        const a = this.createOneEmpty();
        a[0] = x;
        a[1] = y;
        return a;
    }
    copyFromBuffer(memoryDataView, pointer, writeTo = this.createOneEmpty(), littleEndian = Vec2Factory.littleEndian) {
        writeTo[0] = this.dataView.getValue(memoryDataView, pointer, littleEndian);
        writeTo[1] = this.dataView.getValue(memoryDataView, pointer += this.bytesPerElement, littleEndian);
        return writeTo;
    }
    copyToBuffer(memoryDataView, writeFrom, pointer, littleEndian = Vec2Factory.littleEndian) {
        this.dataView.setValue(memoryDataView, pointer, writeFrom[0], littleEndian);
        this.dataView.setValue(memoryDataView, pointer += this.bytesPerElement, writeFrom[1], littleEndian);
    }
}
//# sourceMappingURL=vec2-factory.js.map