import { ITypedArrayTupleFactory } from "../i-typed-array-tuple-factory.js";
import { IVec3Ctor, TVec3CtorArgs, Vec3 } from "./vec3.js";
import { ATypedTupleFactory } from "../a-typed-tuple-factory.js";
import { TTypedArray } from "../t-typed-array.js";
import { INormalizedDataView } from "../normalized-data-view/i-normalized-data-view.js";
export declare class Vec3Factory<T extends Vec3<TTypedArray>> extends ATypedTupleFactory<T, TVec3CtorArgs> implements ITypedArrayTupleFactory<T, TVec3CtorArgs> {
    private ctor;
    constructor(ctor: IVec3Ctor<TTypedArray>, dataView: INormalizedDataView);
    createOneEmpty(): T;
    createOne(x: number, y: number, z: number): T;
    copyFromBuffer(memoryDataView: DataView, pointer: number, writeTo?: T, littleEndian?: boolean): T;
    copyToBuffer(memoryDataView: DataView, writeFrom: Readonly<T>, pointer: number, littleEndian?: boolean): void;
}
