import { ATypedTupleFactory } from "../a-typed-tuple-factory.js";
export class Vec3Factory extends ATypedTupleFactory {
    constructor(ctor, dataView) {
        super(3, ctor.BYTES_PER_ELEMENT, dataView);
        this.ctor = ctor;
    }
    createOneEmpty() {
        return new this.ctor();
    }
    createOne(x, y, z) {
        const a = this.createOneEmpty();
        a[0] = x;
        a[1] = y;
        a[2] = z;
        return a;
    }
    copyFromBuffer(memoryDataView, pointer, writeTo = this.createOneEmpty(), littleEndian = Vec3Factory.littleEndian) {
        writeTo[0] = this.dataView.getValue(memoryDataView, pointer, littleEndian);
        writeTo[1] = this.dataView.getValue(memoryDataView, pointer += this.bytesPerElement, littleEndian);
        writeTo[2] = this.dataView.getValue(memoryDataView, pointer += this.bytesPerElement, littleEndian);
        return writeTo;
    }
    copyToBuffer(memoryDataView, writeFrom, pointer, littleEndian = Vec3Factory.littleEndian) {
        this.dataView.setValue(memoryDataView, pointer, writeFrom[0], littleEndian);
        this.dataView.setValue(memoryDataView, pointer += this.bytesPerElement, writeFrom[1], littleEndian);
        this.dataView.setValue(memoryDataView, pointer += this.bytesPerElement, writeFrom[2], littleEndian);
    }
}
//# sourceMappingURL=vec3-factory.js.map