import { ITypedArrayTupleFactory } from "../i-typed-array-tuple-factory.js";
import { ATypedTupleFactory } from "../a-typed-tuple-factory.js";
import { TTypedArray } from "../t-typed-array.js";
import { IVec4Ctor, TVec4CtorArgs, Vec4 } from "./vec4.js";
import { INormalizedDataView } from "../normalized-data-view/i-normalized-data-view.js";
export declare class Vec4Factory<T extends Vec4<TTypedArray>> extends ATypedTupleFactory<T, TVec4CtorArgs> implements ITypedArrayTupleFactory<T, TVec4CtorArgs> {
    private readonly ctor;
    constructor(ctor: IVec4Ctor<TTypedArray>, dataView: INormalizedDataView);
    createOneEmpty(): T;
    createOne(x: number, y: number, z: number, w: number): T;
    copyFromBuffer(memoryDataView: DataView, pointer: number, writeTo?: T, littleEndian?: boolean): T;
    copyToBuffer(memoryDataView: DataView, writeFrom: Readonly<T>, pointer: number, littleEndian?: boolean): void;
}
