/**
 * @public
 * Bit offset for packed RGBA colors.
 *
 * @remarks
 * After masking zero fill right shift to unpack.
 * Left shift to pack (0-255 as input).
 * Stored as ABGR to allow packing of RGB into float32.
 */
export declare enum ERgbaShift {
    R = 0,
    G = 8,
    B = 16,
    A = 24
}
/**
 * @public
 * Bit mask for packed RGBA colors.
 */
export declare enum ERgbaMasks {
    R = 255,
    G = 65280,
    B = 16711680,
    A = -16777216
}
