import { _Debug } from "./_debug.js";
import { numberGetHexString } from "../number/impl/number-get-hex-string.js";
import { arrayInsertAtIndex } from "../array/impl/array-insert-at-index.js";
export class DebugPointer {
    constructor(pointer, objectConstructor, isStatic, instanceLabel = _Debug.label) {
        this.pointer = pointer;
        this.objectConstructor = objectConstructor;
        this.isStatic = isStatic;
        this.instanceLabel = instanceLabel;
        this.creationCallstack = _Debug.getStackTrace();
    }
    toString() {
        const lines = [
            `WASM address: ${numberGetHexString(this.pointer)}`,
            `Js constructor name: ${this.objectConstructor.name}`,
            "\nCall site stack trace follows:",
            this.creationCallstack,
        ];
        if (this.instanceLabel != null) {
            arrayInsertAtIndex(lines, `Instance label : ${this.instanceLabel}`, 2);
        }
        return lines.join("\n");
    }
}
//# sourceMappingURL=debug-pointer.js.map