import { _Debug } from "./_debug.js";
export class DebugWeakValue {
    constructor(values = new WeakMap()) {
        this.values = values;
    }
    setValue(listener, value) {
        this.values.set(listener, value);
    }
    deleteValue(listener) {
        this.values.delete(listener);
    }
    getValue(listener) {
        _BUILD.DEBUG && _Debug.assert(this.values.has(listener), "expected to find value");
        return this.values.get(listener);
    }
}
//# sourceMappingURL=debug-weak-value.js.map