import { dictionaryValues } from "./impl/dictionary-values.js";
import { dictionaryExtend } from "./impl/dictionary-extend.js";
import { dictionaryCloneExtend } from "./impl/dictionary-clone-extend.js";
import { dictionaryForEach } from "./impl/dictionary-foreach.js";
import { dictionaryPairs } from "./impl/dictionary-pairs.js";
import { dictionaryPush } from "./impl/dictionary-push.js";
/**
 * @public
 * Utilities for 'dictionaries', i.e. \{ [index: string]: any \}.
 */
export declare class _Dictionary {
    /** {@inheritDoc dictionaryCloneExtend} */
    static readonly cloneExtend: typeof dictionaryCloneExtend;
    /** {@inheritDoc dictionaryExtend} */
    static readonly extend: typeof dictionaryExtend;
    /** {@inheritDoc dictionaryForEach} */
    static readonly forEach: typeof dictionaryForEach;
    /** {@inheritDoc dictionaryPairs} */
    static readonly pairs: typeof dictionaryPairs;
    /** {@inheritDoc dictionaryPush} */
    static readonly push: typeof dictionaryPush;
    /** {@inheritDoc dictionaryValues} */
    static readonly values: typeof dictionaryValues;
    private constructor();
}
