/**
 * @public
 * Creates a function that can be called many times but will run at most once.
 *
 * @remarks
 * See {@link fpOnce}.
 */
export function fpOnce(initialize) {
    let item;
    let initialized = false;
    return (...args) => {
        if (initialized) {
            return item;
        }
        initialized = true;
        return item = initialize(...args);
    };
}
//# sourceMappingURL=fp-once.js.map