import { AReferenceCounted } from "./a-reference-counted.js";
import { lifecycleStack } from "../web-assembly/emscripten/lifecycle-stack.js";
/**
 * @public
 * A reference counted object
 */
export class ReferenceCountedOwner extends AReferenceCounted {
    /**
     * Creates a ReferenceCountedOwner bound to `bindToReference`. By default, block scoped is disabled.
     */
    static createOneBound(bindToReference, blockScoped = false) {
        const ref = new ReferenceCountedOwner(blockScoped);
        bindToReference.linkRef(ref);
        if (!blockScoped) {
            ref.release();
        }
        return ref;
    }
    constructor(blockScoped = true) {
        super();
        if (blockScoped) {
            lifecycleStack.register(this);
        }
    }
}
//# sourceMappingURL=reference-counted-owner.js.map