/**
 * @public
 * Like `Array.map` but with a `Map` input. Outputs an `Array`.
 *
 * @returns An array of mapped values.
 *
 * @remarks
 * See {@link mapArrayMap}.
 */
export declare function mapArrayMap<TKey, TValue, TMapped>(map: Map<TKey, TValue>, callback: (value: TValue, key: TKey) => TMapped): TMapped[];
