/**
 * @public
 * Returns a `Promise` which will resolve to `resolveWith` after a delay of `delay` (in milliseconds).
 *
 * @remarks
 * See {@link promiseDelay}.
 */
export function promiseDelay(resolveWith, delay = 4) {
    return new Promise((done) => {
        setTimeout(() => {
            done(resolveWith);
        }, delay);
    });
}
//# sourceMappingURL=promise-delay.js.map