import { __awaiter } from "tslib";
/**
 * @public
 * Returns a Promise of rejection with the supplied error if the `value` is false.
 *
 * @remarks
 * See {@link promiseRejectFalse}.
 */
export function promiseRejectFalse(value, error) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield value;
        if (result === false) {
            return Promise.reject(error);
        }
    });
}
//# sourceMappingURL=promise-reject-false.js.map