import { __awaiter } from "tslib";
/**
 * @public
 * Returns a Promise of rejection with the supplied error if the value is `null` or `undefined`.
 *
 * @remarks
 * See {@link promiseRejectNull}.
 */
export function promiseRejectNull(value, error) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield value;
        if (result == null) {
            return Promise.reject(error);
        }
        // eslint-disable-next-line @typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-return
        return result;
    });
}
//# sourceMappingURL=promise-reject-null.js.map