/**
 * @public
 * Escapes RegExp special characters in strings.
 *
 * @returns The escaped string.
 *
 * @remarks
 * See {@link regexEscapeRegex}.
 */
export function regexEscapeRegex(value) {
    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions#Escaping
    return value.replace(/[.*+\-?^${}()|[\]\\]/g, `\\$&`);
}
//# sourceMappingURL=regex-escape-regex.js.map