/**
 * @public
 *  Returns those items in A not in B, and those items in B not in A.
 * @remarks
 * See {@link setSymmetricDifference}.
 */
export function setSymmetricDifference(a, b) {
    const result = [];
    a.forEach((item) => {
        if (!b.has(item)) {
            result.push(item);
        }
    });
    b.forEach((item) => {
        if (!a.has(item)) {
            result.push(item);
        }
    });
    return result;
}
//# sourceMappingURL=set-symmetric-difference.js.map