import { IEmscriptenDebug, IEmscriptenWrapper } from "./i-emscripten-wrapper.js";
import { IWebAssemblyMemoryMemory } from "../../external/i-web-assembly-memory.js";
import { Emscripten } from "../../external/emscripten.js";
/**
 * @public
 * Exists only with _BUILD.DEBUG true.
 */
export interface IEmscriptenDebugInstance {
    RC_JS_MEMORY_DEBUG_UTIL: IEmscriptenDebug;
}
/**
 * @public
 * Factory for creating wrapped emscripten module.
 */
export declare function getEmscriptenWrapper<TExt extends object, TMod extends object>(memory: IWebAssemblyMemoryMemory, emscriptenModuleFactory: Emscripten.EmscriptenModuleFactory<TMod>, extension?: Partial<TExt>): Promise<IEmscriptenWrapper<TExt & TMod>>;
