import { _Debug } from "../../debug/_debug.js";
import { _Production } from "../../production/_production.js";
import { getGlobal } from "../../runtime/get-global.js";
/**
 * @public
 */
export class LifecycleStack {
    constructor() {
        var _a;
        var _b;
        this.allocationStack = ((_a = (_b = getGlobal())["RC_ALLOCATION_STACK"]) !== null && _a !== void 0 ? _a : (_b["RC_ALLOCATION_STACK"] = []));
    }
    push() {
        const top = [];
        this.allocationStack.push(top);
        return top;
    }
    pop() {
        _BUILD.DEBUG && _Debug.assert(this.allocationStack.length > 0, "attempted to pop empty stack");
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return this.allocationStack.pop();
    }
    register(ref) {
        const top = this.allocationStack[this.allocationStack.length - 1];
        if (top == null) {
            throw _Production.createError("attempted to create shared lifecycle object outside of allocation scope.");
        }
        top.push(ref);
    }
    getSize() {
        return this.allocationStack.length;
    }
}
/**
 * @public
 */
export const lifecycleStack = new LifecycleStack();
//# sourceMappingURL=lifecycle-stack.js.map