import { AReferenceCounted, IReferenceCounted } from "../../lifecycle/a-reference-counted.js";
import { IEmscriptenWrapper } from "../emscripten/i-emscripten-wrapper.js";
import { ILinkedReferences } from "../../lifecycle/linked-references.js";
/**
 * @public
 * Wrapper of wasm object.
 * NB The object is pre-claimed (ref count 1) on creation. On free the pointer will be set to null.
 */
export interface IReferenceCountedPtr extends IReferenceCounted {
    readonly isStatic: boolean;
    getPtr(): number;
}
/**
 * @public
 * Wrapper of wasm object.
 */
export declare class ReferenceCountedPtr extends AReferenceCounted implements IReferenceCountedPtr {
    readonly isStatic: boolean;
    protected wasmPtr: number;
    protected readonly wrapper: IEmscriptenWrapper<object>;
    static createOneBound(bindToReference: ILinkedReferences | null, isStatic: boolean, wasmPtr: number, wrapper: IEmscriptenWrapper<object>): IReferenceCountedPtr;
    getPtr(): number;
    /**
     * DO NOT CALL THIS DIRECTLY, CALL RELEASE.
     */
    protected onFree(): void;
    constructor(isStatic: boolean, wasmPtr: number, wrapper: IEmscriptenWrapper<object>);
}
