/**
 * @internal
 */
export function shimWebAssemblyMemory(memory, onGrowCallback) {
    const grow = memory.grow.bind(memory);
    memory.grow = (pagesToAdd) => {
        const previousPageCount = grow(pagesToAdd);
        onGrowCallback(memory.buffer, previousPageCount, pagesToAdd);
        return previousPageCount;
    };
}
//# sourceMappingURL=shim-web-assembly-memory.js.map