<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [rc-js-util](./rc-js-util.md) &gt; [\_Array](./rc-js-util._array.md)

## \_Array class

Utilities that apply to `Array` and `ArrayLike`<!-- -->.

**Signature:**

```typescript
export declare class _Array 
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [addToSet](./rc-js-util._array.addtoset.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayAddToSet | Adds the items in an array to the set. |
|  [binaryFindInsertionIndex](./rc-js-util._array.binaryfindinsertionindex.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayBinaryFindInsertionIndex | Performs a bisection search of an 'indexable' object such that if the value were inserted, it would remain in order. |
|  [binaryIndexOf](./rc-js-util._array.binaryindexof.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayBinaryIndexOf | Performs a bisection search of an 'indexable' object, i.e. can be accessed by index, for example <code>Array</code>. Custom data structures are also supported. |
|  [binaryLastIndexOf](./rc-js-util._array.binarylastindexof.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayBinaryLastIndexOf | Performs a bisection search of an 'indexable' object, i.e. can be accessed by index, for example <code>Array</code>. Custom data structures are also supported. |
|  [collect](./rc-js-util._array.collect.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayCollect | Like <code>Array.reduce</code> but without the requirement to return the value in the callback. |
|  [compact](./rc-js-util._array.compact.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayCompact | Strips null and undefined items from arrays (non mutative). |
|  [compactMap](./rc-js-util._array.compactmap.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayCompactMap | Like \_Array.map but where the callback returns null it will be omitted from the result. |
|  [contains](./rc-js-util._array.contains.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayContains | Returns true if the item is present in the list (=== equality test). |
|  [copyInto](./rc-js-util._array.copyinto.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayCopyInto | Make an array contain the same items as another. |
|  [emptyArray](./rc-js-util._array.emptyarray.md) | <p><code>static</code></p><p><code>readonly</code></p> | readonly \[\] | An empty readonly array, useful to avoid GC pressure. |
|  [flatMap](./rc-js-util._array.flatmap.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayFlatMap | Iterate over <code>ArrayLike</code> calling a callback against it, the callback returns <code>ArrayLike</code> which is concatenated into a single <code>Array</code>. |
|  [forEach](./rc-js-util._array.foreach.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayForEach | Like <code>Array.forEach</code>. |
|  [forEachRange](./rc-js-util._array.foreachrange.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayForEachRange | Like [arrayForEach()](./rc-js-util.arrayforeach.md) with integer range as input. |
|  [generateRange](./rc-js-util._array.generaterange.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayGenerateRange | Generates a range of integers output in an <code>Array</code>. |
|  [index](./rc-js-util._array.index.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayIndex | Populates a <code>Map</code> given a key creating function and <code>ArrayLike</code>. |
|  [insertAtIndex](./rc-js-util._array.insertatindex.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayInsertAtIndex | Modifies input array by inserting at given index. |
|  [intersect](./rc-js-util._array.intersect.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayIntersect | Given two <code>ArrayLike</code>, provides the items common between them in an <code>Array</code>. |
|  [isArray](./rc-js-util._array.isarray.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayIsArray | Checks if the parameter is an instance of <code>Array</code> or is a view of <code>ArrayBuffer</code>. |
|  [isNotEmpty](./rc-js-util._array.isnotempty.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayIsNotEmpty | Returns true if the argument is not null, undefined or empty. Type narrows to <code>TArray</code> where true. |
|  [last](./rc-js-util._array.last.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayLast | Gets the last value in <code>ArrayLike</code>. |
|  [map](./rc-js-util._array.map.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayMap | Like <code>Array.map</code>. |
|  [mapRange](./rc-js-util._array.maprange.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayMapRange | Like [arrayMap()](./rc-js-util.arraymap.md) with integer range as input. |
|  [max](./rc-js-util._array.max.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayMax | Find the largest number in an array, if the array is empty the return is -Infinity. |
|  [min](./rc-js-util._array.min.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayMin | Find the smallest number in an array, if the array is empty the return is Infinity. |
|  [normalizeEmptyToUndefined](./rc-js-util._array.normalizeemptytoundefined.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayNormalizeEmptyToUndefined | Replaces length 0 <code>ArrayLike</code> with <code>undefined</code>. |
|  [normalizeNullishToEmpty](./rc-js-util._array.normalizenullishtoempty.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayNormalizeNullishToEmpty | Replaces <code>null</code> / <code>undefined</code> with an empty <code>Array</code>. |
|  [pushUnique](./rc-js-util._array.pushunique.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayPushUnique | Like <code>Array.push</code> but checks if the value is unique first. |
|  [removeMany](./rc-js-util._array.removemany.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayRemoveMany | Removes each item in <code>itemsToRemove</code> from <code>items</code> (including any repeated items). |
|  [removeOne](./rc-js-util._array.removeone.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayRemoveOne | Removes either 0 or one item from items, even if itemToRemove appears more than once. |
|  [replaceOne](./rc-js-util._array.replaceone.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayReplaceOne | Replaces the first match of itemToRemove with replaceWith. |
|  [setDifference](./rc-js-util._array.setdifference.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arraySetDifference | returns items in A not in B. |
|  [symmetricDifference](./rc-js-util._array.symmetricdifference.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arraySymmetricDifference | Returns those items in A not in B, and those items in B not in A. |
|  [union](./rc-js-util._array.union.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayUnion | Given an <code>ArrayLike</code> of <code>ArrayLike</code>, provides all unique items in an <code>Array</code>. |
|  [unique](./rc-js-util._array.unique.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof arrayUnique | Creates a new array with no duplicates, using standard object equality. |

