<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [rc-js-util](./rc-js-util.md) &gt; [\_Map](./rc-js-util._map.md)

## \_Map class

Utilities that apply to `Map`<!-- -->.

**Signature:**

```typescript
export declare class _Map 
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [addToSet](./rc-js-util._map.addtoset.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapAddToSet | Used with maps that store sets. Where a set exists for a given key the value will be added to that set, otherwise a new set will be created containing the value. |
|  [arrayMap](./rc-js-util._map.arraymap.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapArrayMap | Like <code>Array.map</code> but with a <code>Map</code> input. Outputs an <code>Array</code>. |
|  [clearingDeleteFromSet](./rc-js-util._map.clearingdeletefromset.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapClearingDeleteFromSet | Used with maps that store sets. Where a set exists for a given key the value will be removed from that set, if it is empty after removal, then the set is deleted. |
|  [concat](./rc-js-util._map.concat.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapConcat | Used with maps that store arrays. Where an array exists for a given key the values will be appended to that array, otherwise a copy of values array will be inserted. |
|  [deleteFromSet](./rc-js-util._map.deletefromset.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapDeleteFromSet | Used with maps that store sets. Where a set exists for a given key the value will be removed from that set. |
|  [deleteGet](./rc-js-util._map.deleteget.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapDeleteGet | Get the stored value if present, then delete the key. |
|  [entriesToArray](./rc-js-util._map.entriestoarray.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapEntriesToArray | Converts a <code>Map</code> into an <code>Array</code> of its key value pairs. |
|  [firstKey](./rc-js-util._map.firstkey.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapFirstKey | Gets the first inserted key in a <code>Map</code>. |
|  [firstValue](./rc-js-util._map.firstvalue.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapFirstValue | Gets the first inserted value in a <code>Map</code>. |
|  [initializeGet](./rc-js-util._map.initializeget.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapInitializeGet | Gets the value from a <code>Map</code> for a given key, where the value is <code>undefined</code> or hasn't been set, the callback's return will be inserted into the <code>Map</code> and returned. |
|  [intersect](./rc-js-util._map.intersect.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapIntersect | <p>Does not check value equality, only key. Takes items from A.</p><p>See [mapIntersect()](./rc-js-util.mapintersect.md)<!-- -->.</p> |
|  [keysToArray](./rc-js-util._map.keystoarray.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapKeysToArray | Converts a <code>Map</code> into an <code>Array</code> of its keys. |
|  [push](./rc-js-util._map.push.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapPush | Used with maps that store arrays. Where an array exists for a given key the value will be appended to that array, otherwise a new array will be created containing the value. |
|  [removeManyFromArray](./rc-js-util._map.removemanyfromarray.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapRemoveManyFromArray | Used with maps that store sets. Where a set exists for a given key the value will be added to that set, otherwise a new set will be created containing the value. |
|  [removeOneFromArray](./rc-js-util._map.removeonefromarray.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapRemoveOneFromArray | Used with maps that store arrays. Where an array exists for a given key the value will be removed from that array. |
|  [reportingAddToSet](./rc-js-util._map.reportingaddtoset.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapReportingAddToSet | Used with maps that store sets. Where a set exists for a given key the value will be added to that set, otherwise a new set will be created containing the value. |
|  [setDifference](./rc-js-util._map.setdifference.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapSetDifference | returns items in A not in B. |
|  [symmetricDifference](./rc-js-util._map.symmetricdifference.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapSymmetricDifference | Returns a map with keys in A not in B, and keys in B not in A. |
|  [union](./rc-js-util._map.union.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapUnion | Returns a map with keys from both A and B. If both A and B have the same key the value from B will be used. |
|  [valuesToArray](./rc-js-util._map.valuestoarray.md) | <p><code>static</code></p><p><code>readonly</code></p> | typeof mapValuesToArray | Converts a <code>Map</code> into an <code>Array</code> of its values. |

