<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [rc-js-util](./rc-js-util.md) &gt; [arrayBinaryLastIndexOf](./rc-js-util.arraybinarylastindexof.md)

## arrayBinaryLastIndexOf() function

Performs a bisection search of an 'indexable' object, i.e. can be accessed by index, for example `Array`<!-- -->. Custom data structures are also supported.

**Signature:**

```typescript
export declare function arrayBinaryLastIndexOf<T>(indexable: T, comparisonValueToSearchFor: number, getComparisonValueAtIndex: TGetComparisonValueAtIndex<T>, length: number, start?: number): number;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  indexable | T | The thing to be searched. This must be sorted ascending. |
|  comparisonValueToSearchFor | number | The comparison value which is being searched for. |
|  getComparisonValueAtIndex | [TGetComparisonValueAtIndex](./rc-js-util.tgetcomparisonvalueatindex.md)<!-- -->&lt;T&gt; | A function that provides the value for comparison at a given index. |
|  length | number | The number of elements in the structure <code>indexable</code> to search. |
|  start | number | _(Optional)_ The start index. |

**Returns:**

number

The index of the searched for item, else -1 if it cannot be found.

## Remarks

The `indexable` parameter must be sorted ascending. Where there are multiple equal values the highest index will be returned.

See [arrayBinaryLastIndexOf()](./rc-js-util.arraybinarylastindexof.md)<!-- -->.

## Example


```typescript
// searching for the number 3 with start index 1 & length 2
 const index = arrayBinaryIndexOf([1, 2, 3, 4], 3, (a, i) => a[i], 2, 1);
 // index is 2
```

