<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [rc-js-util](./rc-js-util.md) &gt; [ATypedArrayTuple](./rc-js-util.atypedarraytuple.md)

## ATypedArrayTuple class

Common methods of typed arrays, extend to make typed array tuples.

**Signature:**

```typescript
export declare class ATypedArrayTuple<TLength extends number, TArray extends TTypedArray> 
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [buffer](./rc-js-util.atypedarraytuple.buffer.md) | <code>readonly</code> | ArrayBufferLike | The ArrayBuffer instance referenced by the array. |
|  [byteLength](./rc-js-util.atypedarraytuple.bytelength.md) | <code>readonly</code> | number | The length in bytes of the array. |
|  [byteOffset](./rc-js-util.atypedarraytuple.byteoffset.md) | <code>readonly</code> | number | The offset in bytes of the array. |
|  [BYTES\_PER\_ELEMENT](./rc-js-util.atypedarraytuple.bytes_per_element.md) | <code>readonly</code> | number | The size in bytes of each element in the array. |
|  [length](./rc-js-util.atypedarraytuple.length.md) | <code>readonly</code> | TLength | The length of the array. |
|  [TTypeGuardTypedArray](./rc-js-util.atypedarraytuple.ttypeguardtypedarray.md) |  | TArray |  |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [copyWithin(\_target, \_start, \_end)](./rc-js-util.atypedarraytuple.copywithin.md) |  | Returns the this object after copying a section of the array identified by start and end to the same array starting at position target |
|  [every(\_callbackfn, \_thisArg)](./rc-js-util.atypedarraytuple.every.md) |  | Determines whether all the members of an array satisfy the specified test. |
|  [fill(\_value, \_start, \_end)](./rc-js-util.atypedarraytuple.fill.md) |  | Returns the this object after filling the section identified by start and end with value |
|  [filter(\_callbackfn, \_thisArg)](./rc-js-util.atypedarraytuple.filter.md) |  | Returns the elements of an array that meet the condition specified in a callback function. |
|  [find(\_predicate, \_thisArg)](./rc-js-util.atypedarraytuple.find.md) |  | Returns the value of the first element in the array where predicate is true, and undefined otherwise. |
|  [findIndex(\_predicate, \_thisArg)](./rc-js-util.atypedarraytuple.findindex.md) |  | Returns the index of the first element in the array where predicate is true, and -1 otherwise. |
|  [forEach(\_callbackfn, \_thisArg)](./rc-js-util.atypedarraytuple.foreach.md) |  | Performs the specified action for each element in an array. |
|  [indexOf(\_searchElement, \_fromIndex)](./rc-js-util.atypedarraytuple.indexof.md) |  | Returns the index of the first occurrence of a value in an array. |
|  [join(\_separator)](./rc-js-util.atypedarraytuple.join.md) |  | Adds all the elements of an array separated by the specified separator string. |
|  [lastIndexOf(\_searchElement, \_fromIndex)](./rc-js-util.atypedarraytuple.lastindexof.md) |  | Returns the index of the last occurrence of a value in an array. |
|  [map(\_callbackfn, \_thisArg)](./rc-js-util.atypedarraytuple.map.md) |  | Calls a defined callback function on each element of an array, and returns an array that contains the results. |
|  [reduce(\_callbackfn, initialValue)](./rc-js-util.atypedarraytuple.reduce.md) |  | Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function. |
|  [reduce(\_callbackfn, initialValue)](./rc-js-util.atypedarraytuple.reduce_1.md) |  | Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function. |
|  [reduceRight(\_callbackfn, initialValue)](./rc-js-util.atypedarraytuple.reduceright.md) |  | Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function. |
|  [reduceRight(\_callbackfn, initialValue)](./rc-js-util.atypedarraytuple.reduceright_1.md) |  | Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function. |
|  [reverse()](./rc-js-util.atypedarraytuple.reverse.md) |  | Reverses the elements in an Array. |
|  [set(\_array, \_offset)](./rc-js-util.atypedarraytuple.set.md) |  | Sets a value or an array of values. |
|  [set(\_array)](./rc-js-util.atypedarraytuple.set_1.md) |  | Sets a value or an array of values. Where an offset is not provided the array must be a tuple of the same length. To perform a partial write from the start of the array, set an offset of 0. |
|  [slice()](./rc-js-util.atypedarraytuple.slice.md) |  |  |
|  [slice(\_start, \_end)](./rc-js-util.atypedarraytuple.slice_1.md) |  |  |
|  [some(\_callbackfn, \_thisArg)](./rc-js-util.atypedarraytuple.some.md) |  | Determines whether the specified callback function returns true for any element of an array. |
|  [sort(\_compareFn)](./rc-js-util.atypedarraytuple.sort.md) |  | Sorts an array. |
|  [subarray(\_begin, \_end)](./rc-js-util.atypedarraytuple.subarray.md) |  | Gets a new this view of the ArrayBuffer store for this array, referencing the elements at begin, inclusive, up to end, exclusive. |
|  [toLocaleString()](./rc-js-util.atypedarraytuple.tolocalestring.md) |  | Converts a number to a string by using the current locale. |
|  [toString()](./rc-js-util.atypedarraytuple.tostring.md) |  | Returns a string representation of an array. |

