<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [rc-js-util](./rc-js-util.md) &gt; [Range2d](./rc-js-util.range2d.md)

## Range2d class

2x2 matrix representing a 2d range.

**Signature:**

```typescript
export declare abstract class Range2d<TArray extends TTypedArray> extends Mat2<TArray> 
```
**Extends:** [Mat2](./rc-js-util.mat2.md)<!-- -->&lt;TArray&gt;

## Remarks

See static properties for constructors. Instances are not an extension of this class, but of the static members.

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  ["0"](./rc-js-util.range2d._0_.md) |  | number | xMin |
|  ["1"](./rc-js-util.range2d._1_.md) |  | number | xMax |
|  ["2"](./rc-js-util.range2d._2_.md) |  | number | yMin |
|  ["3"](./rc-js-util.range2d._3_.md) |  | number | yMax |
|  [constructor](./rc-js-util.range2d.constructor.md) |  | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;TArray&gt; |  |
|  [constructors](./rc-js-util.range2d.constructors.md) | <p><code>protected</code></p><p><code>static</code></p> | Map&lt;[TTypedArrayCtor](./rc-js-util.ttypedarrayctor.md)<!-- -->, Function&gt; |  |
|  [f32](./rc-js-util.range2d.f32.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Float32Array&gt; |  |
|  [f64](./rc-js-util.range2d.f64.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Float64Array&gt; |  |
|  [i16](./rc-js-util.range2d.i16.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Int16Array&gt; |  |
|  [i32](./rc-js-util.range2d.i32.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Int32Array&gt; |  |
|  [i8](./rc-js-util.range2d.i8.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Int8Array&gt; |  |
|  [TTypeGuardRange2d](./rc-js-util.range2d.ttypeguardrange2d.md) |  | true |  |
|  [u16](./rc-js-util.range2d.u16.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Uint16Array&gt; |  |
|  [u32](./rc-js-util.range2d.u32.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Uint32Array&gt; |  |
|  [u8](./rc-js-util.range2d.u8.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Uint8Array&gt; |  |
|  [u8c](./rc-js-util.range2d.u8c.md) | <code>static</code> | [IRange2dCtor](./rc-js-util.irange2dctor.md)<!-- -->&lt;Uint8ClampedArray&gt; |  |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [bound(\_boundTo)](./rc-js-util.range2d.bound.md) |  | Bound this range to the argument. |
|  [castToBaseType()](./rc-js-util.range2d.casttobasetype.md) |  | Although the typed array tuples extend a typed array, they are not structurally compatible. This function returns the argument passed without modification but cast as the underlying storage type, e.g. Float32Array. |
|  [containsRange(\_range)](./rc-js-util.range2d.containsrange.md) |  |  |
|  [copyFromBuffer(\_memoryDataView, \_pointer, \_littleEndian)](./rc-js-util.range2d.copyfrombuffer.md) |  | If endianness is not supplied the platform's endianness will be used. |
|  [copyToBuffer(\_memoryDataView, \_pointer, \_littleEndian)](./rc-js-util.range2d.copytobuffer.md) |  | If endianness is not supplied the platform's endianness will be used. |
|  [doesRangeIntersect(\_range)](./rc-js-util.range2d.doesrangeintersect.md) |  |  |
|  [ensureAABB()](./rc-js-util.range2d.ensureaabb.md) |  |  |
|  [ensureMinRange(\_xMinRange, \_yMinRange)](./rc-js-util.range2d.ensureminrange.md) |  | Bound this range to be at least as large as the argument. |
|  [extendRange(\_x, \_y, \_writeTo)](./rc-js-util.range2d.extendrange.md) |  |  |
|  [getCenter(\_result)](./rc-js-util.range2d.getcenter.md) |  |  |
|  [getCtor(ctor)](./rc-js-util.range2d.getctor.md) | <code>static</code> |  |
|  [getRange(\_result)](./rc-js-util.range2d.getrange.md) |  |  |
|  [getRangeTransform(\_toRange, \_result)](./rc-js-util.range2d.getrangetransform.md) |  | Creates a transform matrix that maps values in this range onto <code>_toRange</code>. |
|  [getXCenter()](./rc-js-util.range2d.getxcenter.md) |  |  |
|  [getXMax()](./rc-js-util.range2d.getxmax.md) |  |  |
|  [getXMaxAbs()](./rc-js-util.range2d.getxmaxabs.md) |  |  |
|  [getXMin()](./rc-js-util.range2d.getxmin.md) |  |  |
|  [getXRange()](./rc-js-util.range2d.getxrange.md) |  |  |
|  [getYCenter()](./rc-js-util.range2d.getycenter.md) |  |  |
|  [getYMax()](./rc-js-util.range2d.getymax.md) |  |  |
|  [getYMaxAbs()](./rc-js-util.range2d.getymaxabs.md) |  |  |
|  [getYMin()](./rc-js-util.range2d.getymin.md) |  |  |
|  [getYRange()](./rc-js-util.range2d.getyrange.md) |  |  |
|  [isPointInRange(\_point)](./rc-js-util.range2d.ispointinrange.md) |  |  |
|  [mat3Multiply(\_mat, \_writeTo)](./rc-js-util.range2d.mat3multiply.md) |  |  |
|  [scaleRelativeTo(\_scalingFactor, \_relativeTo, \_result)](./rc-js-util.range2d.scalerelativeto.md) |  | Scales the range relative to a point (may not be outside of the range). |
|  [setXMax(\_value)](./rc-js-util.range2d.setxmax.md) |  |  |
|  [setXMin(\_value)](./rc-js-util.range2d.setxmin.md) |  |  |
|  [setYMax(\_value)](./rc-js-util.range2d.setymax.md) |  |  |
|  [setYMin(\_value)](./rc-js-util.range2d.setymin.md) |  |  |
|  [translateBy(\_dx, \_dy)](./rc-js-util.range2d.translateby.md) |  | Shifts the range by (dx, dy). |
|  [unionRange(\_range, \_writeTo)](./rc-js-util.range2d.unionrange.md) |  |  |
|  [update(\_args)](./rc-js-util.range2d.update.md) |  |  |

